unit filerout;

{$I+}

interface

type
 TSearchReplace = record
                    SearchWhat : String;
                    ReplaceBy  : String;
                  end;
 TSearchReplaceArray = array of TSearchReplace;

function ParseParameterString: Boolean;

function ReplaceText(
  const OldFile: String;
  const NewFile :String): LongInt;

const
 err_noSource =  1;    //'-  .';
 err_SourceNA = 2;     //'-  .';
 err_noSearch = 3;     //'   .';
 err_noReplace = 4;    //'   .';
 err_InvalidPfile = 5; //'   PFILE.';
 err_err = 6;          //': ';
 err_inv = 7;          //'      .';
var
 LastErr : record
              ErrNo  : Byte;
              ErrMsg : String;
            end;
 { }

  isCaseSensetive : Boolean; {  }
  isMultipleReplaces : Boolean;
  SOURCE :String; { , }
  TARGET :String; { ,  ,
                      SOURCE}
 SearchReplace : TSearchReplaceArray; { }

implementation

uses sysutils,classes;


function ParseSearchReplace(const SEARCH : String; const REPLACE : String):Byte;

function SeparatorsCount(const S : String): Integer;
{    .}
var
 i : Integer;
begin
 result := 0;
 if Pos(';',S)=1 then result := 1;
 i := 2;
 while i <= Length(S) do
 begin
 if (S[i] = ';') and (S[i-1] <> '\') then inc(result);
 inc(i);
 end;
end;

function NextPart(var s : String):String;
var
 i : Integer;
 Found : Boolean;
begin

 Found := False;
 result := '';

 repeat
  i:=pos(';',s);
  if i = 0
   then
    begin
     result := result+s;
     Found := True;
    end
   else
    if i = 1
     then
       begin
        result := result+'';
        s := copy(s,i+1,length(s));
        Found := True;
       end
     else
      if s[i-1] = '\'
      then
       begin
        result := result+copy(s,1,i-2)+s[i];
        s := copy(s,i+1,length(s));
       end
      else
       begin
        result := result+copy(s,1,i-1);
        s := copy(s,i+1,length(s));
        Found := True;
       end;
 until Found;

end;

{      }
var
 i,j : Integer;
 s,r : String;
begin
 result := 0;
 if not isMultipleReplaces
 then
  begin
    SetLength(SearchReplace,1);
    SearchReplace[0].SearchWhat := SEARCH;
    SearchReplace[0].ReplaceBy  := REPLACE;
    result := 0;
  end
 else
 begin
    s:= SEARCH;
    r:= REPLACE;
    i := SeparatorsCount(SEARCH);
    j := SeparatorsCount(REPLACE);
    if i <> j
    then //error
     result := err_inv
    else
     begin
    SetLength(SearchReplace,i+1);

    for j:= 0 to i do
    begin
      SearchReplace[j].SearchWhat := NextPart(s);
      SearchReplace[j].ReplaceBy := NextPart(r);
    end;
     end; //i<>j

 end;  {if multiple...}


end;

procedure UpperKeys(PL : TStringList);
{   
  }
var
k : Integer;
begin
for k := 0 to PL.Count-1 do
 Pl[k] := UpperCase(Copy(Pl[k],1,Pos('=',Pl[k])-1))
           +Copy(Pl[k],Pos('=',Pl[k]),Length(Pl[k])+1);
end;

function ParseParameterString: Boolean;
{    
   }
var
 i : Integer;
 PL,PlPfile : TStringList;
 Pfile,IgnCase,MultRepl : String;
 SEARCH :String; { }
 REPLACE:String; {   }

begin

 Result := True;

 PL := TStringList.Create;
 try

  for i := 1 to ParamCount do
   PL.Add(ParamStr(i));
   UpperKeys(PL);
  {  }

   Pfile := Pl.Values['PFILE'];

  if Pfile <> ''
  then
  begin
    PlPfile := TStringList.Create;
    try
     try
      PlPfile.LoadFromFile(Pfile);
      UpperKeys(PlPfile);
      SOURCE := PlPfile.Values['SOURCE'];
      TARGET := PlPfile.Values['TARGET'];
      SEARCH := PlPfile.Values['SEARCH'];
      REPLACE := PlPfile.Values['REPLACE'];
      IgnCase := PlPfile.Values['IGNORECASE'];
      MultRepl := PlPfile.Values['MULTIPLEREPLACES'];
     except
      Result := False;
      LastErr.ErrNo := err_InvalidPfile;
     end;
    finally
      PlPfile.Free;
    end;

  end;

  if Pl.Values['SOURCE'] <> '' then SOURCE := Pl.Values['SOURCE'];
  if Pl.Values['TARGET'] <> '' then TARGET := Pl.Values['TARGET'];
  if Pl.Values['SEARCH'] <> '' then SEARCH := Pl.Values['SEARCH'];
  if Pl.Values['REPLACE'] <> '' then REPLACE := Pl.Values['REPLACE'];
  if Pl.Values['IGNORECASE'] <> '' then IgnCase := Pl.Values['IGNORECASE'];
  if Pl.Values['MULTIPLEREPLACES'] <> '' then MultRepl := Pl.Values['MULTIPLEREPLACES'];

 finally
  Pl.Free;
 end; {finally}

 if TARGET = '' then TARGET := SOURCE;
 if (IgnCase = 'Y') or (IgnCase = 'y')  then isCaseSensetive := False;
 if (UpperCase(MultRepl) = 'N') then isMultipleReplaces := False;
 if SOURCE = ''
 then
  begin
   LastErr.ErrNo := err_noSource;
   Result := False;
  end;

 if SEARCH = ''
 then
  begin
   LastErr.ErrNo := err_noSearch;
   Result := False;
  end;

 if REPLACE = ''
 then
  begin
   LastErr.ErrNo := err_noReplace;
   Result := False;
  end;

  if LastErr.ErrNo = 0
  then
   begin
   LastErr.ErrNo := parseSearchReplace(SEARCH,REPLACE);
    if LastErr.ErrNo <> 0
    then
     Result := False;
    end;
end;

function ReplaceText(
  const OldFile: String;
  const NewFile :String
  ): LongInt;

 {  }

procedure ReplaceInString(var S : String; var i : LongInt);
{    }

function GetCasedItem(const src : String): String;
{ ,    .}
begin
if isCaseSensetive
then
  result := src
else
  result := UpperCase(src);
end;


var
 svar : String;
 l : Integer;
 isReplaceMade : Boolean;
begin
 svar := S;
 S := '';

 isReplaceMade := False;
 {   -     
  +   }

   for l := 0 to High(SearchReplace) do
   begin
    while Pos(GetCasedItem(SearchReplace[l].SearchWhat),
              GetCasedItem(Svar)) > 0  do
     begin
     inc(i);
      isReplaceMade := True;
      S := S+Copy(Svar,1,Pos(GetCasedItem(SearchReplace[l].SearchWhat),
                  GetCasedItem(Svar))-1)+SearchReplace[l].ReplaceBy;

      Svar :=  Copy(Svar,Pos(GetCasedItem(SearchReplace[l].SearchWhat),
               GetCasedItem(Svar))
       +Length(SearchReplace[l].SearchWhat),Length(svar)+1);
    end; {while}
      S :=S+Svar;
     {   s -   svar - 
        }
     if isReplaceMade
      then
       begin
         svar := s;
         s := '';
         isReplaceMade := False;
       end;
   end; {for}

   s:= svar;

end;

var
 i,j : LongInt;
 F,V : TextFile;
 S   : String;
 Fs  : TStringList;
begin

  i:=0;

 if not FileExists(OldFile)
 then
  begin
   LastErr.ErrNo := err_SourceNA;
   i:= -1;
  end
 else
  begin
   if UpperCase(NewFile) = UpperCase(OldFile)
    then
     begin
      {    }
    try
      Fs := TStringList.Create;
      with Fs do
      begin
       try
         LoadFromFile(NewFile);
         for j := 0 to Count-1 do
         begin
          S:= Fs[j];
          ReplaceInString(S,i);
          Fs[j] := S;
         end;
         if i > 0 then
         SaveToFile(NewFile);
       finally
        Free;
       end;
      end;
     except
        on E: Exception do
         begin
          i:=-1;
          LastErr.ErrNo := err_err;
          LastErr.ErrMsg := E.Message;
         end;
     end {except}
    end
    else
     begin
      {   }
       try
        AssignFile(F,OldFile);
        AssignFile(V,NewFile);
        Reset(F);
        Rewrite(V);
        while not EOF(F) do
         begin
          ReadLn(F,S);
          ReplaceInString(S,i);
          WriteLn(V,S);
         end;
        CloseFile(F);
        CloseFile(V);
       except
        on E: Exception do
         begin
          i:=-1;
          LastErr.ErrNo := err_err;
          LastErr.ErrMsg := E.Message;
         end;
       end;
     end;

  end;

   Result := i;

end;




initialization

isCaseSensetive := True;
isMultipleReplaces := True;
LastErr.ErrNo := 0;
LastErr.ErrMsg := '';

end.
